/*

 */

#include "ext.h"


#define NROW 4
#define NCOL 2400000


typedef struct
{
  t_object o;

  int   pre;
  int   fois;
  int   iter;

  float *data;

  void *outlet_0;
  void *outlet_1;
} arraytest_t;


void *arraytest_class;


static void
arraytest_sendparam (t_object *o, long a, long b, long c)
{
  arraytest_t *self = (arraytest_t *) o;

  self->pre  = a;
  self->fois = b;
  self->iter = c;

  outlet_int(self->outlet_1, a);
  outlet_int(self->outlet_1, b);
  outlet_int(self->outlet_1, c);
}



static void
arraytest_prefill (t_object *o)
{
  arraytest_t *self = (arraytest_t *) o;
  int i;

  for (i = 0; i < self->pre; i++)
  {
    float ii = (float) i;
    self->data[0 + i * NROW] = ii / 140000.0;
    self->data[1 + i * NROW] = ii / 130000.0;
    self->data[2 + i * NROW] = ii / 120000.0;
    self->data[3 + i * NROW] = ii / 110000.0;
  }

  outlet_int(self->outlet_0, 1);
}


static void
arraytest_writetest (t_object *o)
{
  arraytest_t *self = (arraytest_t *) o;
  int i, j;

  for (i = 0; i < self->fois * 100; i++)
  {
/*    float *ptr = self->data + self->pre * NROW; */

    for (j = self->pre; j < self->pre + self->iter; j++)
    {
#if 0      
      ptr[0] = 0.66;
      ptr[1] = 0.77;
      ptr[2] = 0.88;
      ptr[3] = 0.99;

      ptr += NROW;
#else
      self->data[0 + j * NROW] = 0.66;
      self->data[1 + j * NROW] = 0.77;
      self->data[2 + j * NROW] = 0.88;
      self->data[3 + j * NROW] = 0.99;
#endif
    }
  }

  outlet_int(self->outlet_0, 2);
}


static void
arraytest_readtest (t_object *o)
{
  arraytest_t *self = (arraytest_t *) o;
  int i, j;
  float f1, f2, f3, f4;

  for (i = 0; i < self->fois * 100; i++)
  {
    for (j = self->pre; j < self->pre + self->iter; j++)
    {
      f1 = self->data[0 + j * NROW];
      f2 = self->data[1 + j * NROW];
      f3 = self->data[2 + j * NROW];
      f4 = self->data[3 + j * NROW];
    }
  }

  outlet_int(self->outlet_0, 3);
  outlet_float(self->outlet_1, f1);
  outlet_float(self->outlet_1, f2);
  outlet_float(self->outlet_1, f3);
  outlet_float(self->outlet_1, f4);
}



/***************************************************************
*
* class
*
*/

static void *arraytest_new (Symbol *s, short ac, Atom *at)
{ 
  arraytest_t *self = (arraytest_t *) newobject(arraytest_class);

  post("this is arraytest!\n");

  self->data = malloc(NROW * NCOL * sizeof(float));

  self->outlet_1 = outlet_new((t_object *) self, 0);
  self->outlet_0 = outlet_new((t_object *) self, 0);

  return self;
}


static void arraytest_free (arraytest_t *self)
{
  free(self->data);
}


void main (void)
{
    setup((t_messlist **) &arraytest_class, (method) arraytest_new, (method) arraytest_free, (short) sizeof(arraytest_t), 0, A_GIMME, 0);
    
    /* inlet method */
    addmess((method) arraytest_sendparam, "sendparam", A_LONG, A_LONG, A_LONG, 0);
    addmess((method) arraytest_prefill,   "prefill",   0);
    addmess((method) arraytest_writetest, "writetest", 0);
    addmess((method) arraytest_readtest,  "readtest",  0);
}

/** EMACS **
* Local variables:
* mode: c
* c-basic-offset:2
* End:
*/
